package przyklady;

import hr.model.Location;
import jakarta.persistence.EntityManager;
import jakarta.persistence.EntityManagerFactory;
import jakarta.persistence.Persistence;

public class P9_DetachMerge {

    public static void main(String[] args) {
        try(EntityManagerFactory emf = Persistence.createEntityManagerFactory("hr");
            EntityManager em = emf.createEntityManager()) {
            em.getTransaction().begin();

            Location lokalizacja = em.find(Location.class, 1100);
            System.out.println(lokalizacja);

            System.out.println("detach");
            em.detach(lokalizacja);

            System.out.println(lokalizacja);
            System.out.println("Zmieniam pole");
            lokalizacja.setCity("WENECJA");
            System.out.println(lokalizacja);

            System.out.println("Ponowny find");
            Location lokalizacjaFind = em.find(Location.class, 1100);
            System.out.println(lokalizacjaFind);

            System.out.println("merge");
            Location lokalizacjaMerge = em.merge(lokalizacja);
            System.out.println("l : " + lokalizacja);
            System.out.println("lf: " + lokalizacjaFind);
            System.out.println("lm: " + lokalizacjaMerge);
            
            em.getTransaction().rollback();
            System.out.println("Zrolowano.");
        }
    }
}
